#include	<ext.h>
#include	<stdarg.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<math.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"filters.h"
#include	"cont_pat.h"
#include	"text_st.h"
#include	"page_con.h"
#include	"windinfo.h"


#define ULONG		unsigned long
#define contents	(input_stream.output)

struct fonts *SetFont (WIND_LIST *wind, char *name, struct page_resource *resource);

extern struct Character_encoding Latin_encoding[];


extern X_GEM_INFO *x_gem;
extern WIND_LIST windows[];
extern struct opt options;
extern OBJECT *adr_doc_info;

extern struct fonts *base_font;

extern char *types_command[];


void add_pdf_object (WIND_LIST *wind, short type, ...);
void clear_all_pdf_objects (WIND_LIST *wind);


#define CONTENTS_COMM_LENGTH	1
#define CONTENTS_COMM_FILTER	2
#define CONTENTS_COMM_STREAM	3

extern struct Text_State text_state;									/* This is the main variable needed by text positioning!!	*/


int hex2dec4(char *hex)
	{
	int out=0;
	
	if(isdigit(hex[0]))
		out = 4096*(hex[0] - '0');
	else
		out = (4096*(toupper(hex[0]) - 'A' + 10));

	if(isdigit(hex[1]))
		out += 256*(hex[1] - '0');
	else
		out += (256*(toupper(hex[1]) - 'A' + 10));

	if(isdigit(hex[2]))
		out += 16*(hex[2] - '0');
	else
		out += (16*(toupper(hex[2]) - 'A' + 10));

	if(isdigit(hex[3]))
		out += (hex[3] - '0');
	else
		out += (toupper(hex[3]) - 'A' + 10);

	return(out);
	}


int hex2dec2(char *hex)
	{
	int out=0;
	
	if(isdigit(hex[0]))
		out = 16*(hex[0] - '0');
	else
		out = 16*toupper(hex[0]) - 'A' + 10;

	if(isdigit(hex[1]))
		out += (hex[1] - '0');
	else
		out += (toupper(hex[0]) - 'A' + 10);

	return(out);
	}


int octal2dec(char *octal)
	{
	int out=0;

	out += 1*atoi(&octal[2]);	octal[2] = 0;
	out += 8*atoi(&octal[1]);	octal[1] = 0;
	out += 64*atoi(&octal[0]);

	return(out);
	}


int GetCharFromDifference(int ch, struct fonts *current_font, int type)
	{
	int i;
	struct Character_encoding *encoding=NULL;
	
	if(current_font==NULL && type==2)
	{
	for(i=0; Latin_encoding[i].code.standard!=-1; i++)
		{
		if(ch == Latin_encoding[i].code.pdf)
			return(Latin_encoding[i].code.mac);
		}
	}
	encoding = (struct Character_encoding*) current_font->encoding.differences;

	if(current_font->encoding.differences!=NULL)
		{
		for(i=0; encoding[i].code.standard!=-1; i++)
			{
			if(ch == encoding[i].code.new_code)
				return(encoding[i].code.standard);
			}
		}
	else if(type==1 && current_font->encoding.differences==NULL)
		{
		for(i=0; Latin_encoding[i].code.standard!=-1; i++)
			{
			if(ch == Latin_encoding[i].code.pdf)
				return(Latin_encoding[i].code.standard);
			}
		}
	else
		{
		return(ch);
		}
	return(ch);
	}


INT16 GetCharWidth(int ch, struct fonts *font, double scale)
	{
	INT16 output, d1, d2;
	
	if(font->width_table==NULL)
		vqt_width(x_gem->handle, ch, &output, &d1, &d2);
	else
		output = (INT16)(font->width_table[ch]/100);

	vqt_width(x_gem->handle, ch, &output, &d1, &d2);

/*	output = (INT16)(scale * (double)scale));	*/

	return(output);
	}


void Plot_Width(int handle, int x_pos, int y_pos, int height, int cell_width)
	{
	static int color;
	int pxy[12]={0};

	y_pos += height;

	pxy[0] = x_pos;									pxy[1] = y_pos;
	pxy[2] = pxy[0] + cell_width;		pxy[3] = y_pos;
	pxy[4] = pxy[0] + cell_width;		pxy[5] = y_pos-height;
	pxy[6] = pxy[0];		pxy[7] = y_pos-height;
	pxy[8] = pxy[0];		pxy[9] = y_pos;
	vsl_color(handle, ++color);
	if(color>15)
		color=1;
	v_pline(handle, 5, (INT16*)pxy);
	vsl_color(handle, BLACK);

	}


/* *******************************************************************************
			read_text - reads the text between brackets and the hex text
	 *******************************************************************************
	source - the stream that contains the text
	destinantion - where the new text should be stored
	len_in - the length of the source text
	len_out - the length of the saved text
	font_type - type of the font
	TJ - is it TJ or Tj
*/

BOOLEAN read_text(char *source, char *destination, int *len_in, int *len_out, int font_type, BOOLEAN TJ, struct fonts *current_font)
	{
	int so=0, de=0, i;
	char *special1[]={"\\r", "\\n", "\\t", "\\b", "\\f", "\\(", "\\)", "\\\\", NULL};
	char special2[]={'\r', '\n', '\t', '\b', '\f', '(',	')',	'\\'};
	char octal[4]={0};
	int len2;


	if(len_out==NULL)
		len_out = &len2;

	(*len_out) = 0;
	(*len_in) = 0;

	if(source==NULL || destination==NULL || strlen(source)==0)
		{
		(*len_out) = -1;
		return(FALSE);
		}

	if(source[so]=='(' || source[so+1]=='(')				/* The text is NOT in hex format	*/
		{
		so++;
		if(source[so]=='(')
			so++;

		for(; source[so]!=')'; so++, de+=2, (*len_out)+=2, (*len_in)+=1)
			{
			source[so] = GetCharFromDifference(source[so], current_font, 0);

			if(source[so]=='\\')
				{
				for(i=0; special1[i]!=NULL; i++)
					{
					if(strncmp(&source[so], special1[i], 2)==0)
						{
						destination[de+1] = GetCharFromDifference(special2[i], current_font, 0)  - 29;
						so++;
						break;
						}
					}
				if(special1[i]==NULL)		/* This is a octal character	"\ddd"	*/
					{
					if(isdigit(source[++so]))
						octal[0] = source[so++];

					if(source[so]!='\\')		/* Octal	*/
						{
						if(isdigit(source[so]))
							octal[1] = source[so++];
						if(isdigit(source[so]))
							octal[2] = source[so++];
						destination[de+1] = GetCharFromDifference(octal2dec(octal), current_font, 1)  - 29;

						so--;
						(*len_in) += 3;
						}
					else			/* Hexadecimal	*/
						{
						octal[0] = source[so++];
						if(isdigit(source[so]) || isalpha(source[so]))
							octal[2] = source[so];
						destination[de+1] = hex2dec2(octal);
						}
					}
				}
			else
				{
				if(font_type==3)
					destination[de+1] = source[so];	/* + (65 - current_font->first_char) + 32;	*/
				else
					destination[de+1] = source[so] - 29;	/* ER: better to understand the text */
				}
			}
		}
	else if(source[so]=='<' || source[so+1]=='<')														/* The text IS in hex format	*/
		{
		so++;
		while(source[so]!='>')
			{
			destination[de+1] = hex2dec4(&source[so]);
			so += 4;
			de+=2;
			(*len_out)+=2;
			(*len_in)+=4;
			}
		}

	return(TRUE);
	}



/*
	The text position begins at (x,y).
	Then the position of each character is increased: Tc (for characters) or Tw (for words - if the charater == 32).
	We have also think about Th (Tz) - horizontal scaling.
*/

void Display_text(short handle, int x, int y, OB_Tj *Tj, BOOLEAN TJ, struct PDF_Info *pdf_info)
	{
	short dummy=0, i=0;
	short text_out[256]={0}, pxy[16]={0}, x_pos=x + (int)(pdf_info->scale*(double)Tj->pos_x), y_pos=y + pdf_info->page_h - (int)(pdf_info->scale*(double)Tj->pos_y);
	short cell_width=0;
	char character;

	Tj->Tc = 0;
	Tj->Tw = 0;

	if(TJ==FALSE)			/* (xadsd)Tj	*/
		{
		INT16 *offset=NULL;

		offset = calloc(1, Tj->len*4*sizeof(INT16));
		for(i=0; i<Tj->len; i++)
			{
			offset[2*i+1] = 0;			/* Offset Y is always 0	*/

			character = Tj->text[i]+29;

			if(character==32)
				offset[2*i] = (INT16)cell_width + (INT16)(pdf_info->scale*(double)Tj->Tw);
			else
				offset[2*i] = (INT16)cell_width + (INT16)((pdf_info->scale*(double)Tj->Tc)/1000L);

			cell_width = GetCharWidth(character, Tj->actual_font, pdf_info->scale);
			}
		vst_color (handle, Tj->color);
		vst_height (handle, (int)(pdf_info->scale*(double)Tj->Tfs), &dummy, &dummy, &dummy, &dummy);
		vst_rotation (handle, Tj->rotate);
		vswr_mode (handle, MD_TRANS);
		vst_charmap (handle, 0);
		v_ftext16 (handle, x_pos, y_pos, Tj->text, Tj->len);
		vst_charmap (handle, 1);
		free(offset);
		}

	else							/* [(asdas)6.2(12asdasd)-0.1(asd)]TJ		*/

		{
		vst_color (handle, Tj->color);
		vst_height (handle, (int)(pdf_info->scale*(double)Tj->Tfs), &dummy, &dummy, &dummy, &dummy);
		vst_rotation (handle, -Tj->rotate);
		vswr_mode (handle, MD_TRANS);

		for(i=0; i<Tj->len; i++)
			{
			character = Tj->text[i]+29;
			if(character==32)
				{
				if(Tj->rotate==900)
					y_pos += ((short)(pdf_info->scale*(double)Tj->Tw) + cell_width + (short)((pdf_info->scale*(double)Tj->dis_x[i])/1000UL));
				else if(Tj->rotate==2700)
					y_pos += ((short)(pdf_info->scale*(double)Tj->Tw) + cell_width + (short)((pdf_info->scale*(double)Tj->dis_x[i])/1000UL));
				else
					x_pos += ((short)(pdf_info->scale*(double)Tj->Tw) + cell_width + (short)((pdf_info->scale*(double)Tj->dis_x[i])/1000UL));
				}
			else
				{
				if(Tj->rotate==900)
					y_pos += ((short)((pdf_info->scale*(double)Tj->Tc)/1000L) + cell_width + (short)((pdf_info->scale*(double)Tj->dis_x[i])/1000UL));
				else if(Tj->rotate==2700)
					y_pos -= ((short)((pdf_info->scale*(double)Tj->Tc)/1000L) + cell_width + (short)((pdf_info->scale*(double)Tj->dis_x[i])/1000UL));
				else
					x_pos += ((short)((pdf_info->scale*(double)Tj->Tc)/1000L) + cell_width + (short)((pdf_info->scale*(double)Tj->dis_x[i])/1000UL));
				}
			cell_width = GetCharWidth(character, Tj->actual_font, pdf_info->scale);
/*			Plot_Width(handle, x_pos, y_pos, (int)(pdf_info->scale*(double)Tj->Tfs), cell_width);
*/
			vst_charmap (handle, 0);
			v_ftext16 (handle, x_pos, y_pos, &Tj->text[i], 1);
			vst_charmap (handle, 1);
			}

		vst_charmap (handle, 1);
		}

/*	free(buf);	*/
	}