#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"filters.h"
#include	"cont_pat.h"


extern X_GEM_INFO *x_gem;
extern void add_pdf_object (WIND_LIST *wind, short type, ...);

int Command2ID(struct files_pdf *file, char **table);
unsigned long Read_object_no(struct files_pdf *file);
struct Rectangle *Read_rectangle(struct files_pdf *file);

BOOLEAN GoToObject(struct PDF_Info *info, unsigned int obj);
BOOLEAN GoBack(struct PDF_Info *info);

struct fonts *Add_font(struct fonts *font);


extern struct Character_encoding Latin_encoding[];
extern struct Character_encoding MacExpert_encoding[];
extern char *types_command[];


#define	FONT_DES_TYPE						1
#define	FONT_DES_ASCENT					2
#define	FONT_DES_CAPHEIGHT			3
#define	FONT_DES_DESCENT				4
#define	FONT_DES_FLAGS					5
#define	FONT_DES_FONTBBOX				6
#define	FONT_DES_FONTNAME				7
#define	FONT_DES_ITALIC					8
#define	FONT_DES_STEMV					9
#define	FONT_DES_AVGWIDTH				10
#define	FONT_DES_FONTFILE2			11
#define	FONT_DES_FONTFILE3			12
#define	FONT_DES_LEADING				13
#define	FONT_DES_MAXWIDTH				14
#define	FONT_DES_MISSINGWIDTH		15
#define	FONT_DES_STEMH					16
#define	FONT_DES_XHEIGHT				17
#define	FONT_DES_CHARSET				18

char *fonts_descriptor_command[]={
	"/Type",								/* name 	(Required) The type of PDF object that this dictionary describes; must be
																FontDescriptor for a font descriptor.	*/
	"/Ascent",							/*  number (Required) The maximum height above the baseline reached by glyphs in this
																font, excluding the height of glyphs for accented characters.	*/
	"/CapHeight",							/*  number (Required) The y coordinate of the top of flat capital letters, measured from
																the baseline.	*/
	
	"/Descent",							/* number	(Required) The maximum depth below the baseline reached by glyphs in this
																font. The value is a negative number.	*/
	"/Flags",								/* integer	(Required) A collection of flags defining various characteristics of the font
																(see Section 5.7.1, Font Descriptor Flags).	*/
	"/FontBBox",						/* rectangle (Required) A rectangle (see Section 3.8.3, Rectangles), expressed in the
																glyph coordinate system, specifying the font bounding box. This is the smallest
																rectangle enclosing the shape that would result if all of the glyphs of the
																font were placed with their origins coincident and then filled.	*/
	"/FontName",						/* (Required) The PostScript name of the font. This should be the same as the
																value of BaseFont in the font or CIDFont dictionary that refers to this font
																descriptor.	*/
	"/ItalicAngle",					/* 	number	(Required) The angle, expressed in degrees counterclockwise from the vertical,
																of the dominant vertical strokes of the font. (For example, the 9-oclock
																position is 90 degrees, and the 3-oclock position is 90 degrees.) The value is
																negative for fonts that slope to the right, as almost all italic fonts do.	*/
	"/StemV",								/* 		number	(Required) The width, measured in the x direction, of the dominant vertical
																stems of glyphs in the font.	*/
	"/AvgWidth",						/* 	number	(Optional) The average width of glyphs in the font. Default value: 0.
																FontFile	stream	(Optional) A stream containing a Type 1 font program (see Section 5.8, Embedded
																Font Programs).	*/
	"/FontFile2",						/* 	stream	(Optional; PDF 1.1) A stream containing a TrueType font program (see
																Section 5.8, Embedded Font Programs).	*/
	"/FontFile3",						/* 	stream	(Optional; PDF 1.2) A stream containing a font program other than Type 1 or
																TrueType. The format of the font program is specified by the Subtype entry
																in the stream dictionary (see Section 5.8, Embedded Font Programs, and
																implementation note 45 in Appendix H).
																Note: At most, only one of the FontFile, FontFile2, and FontFile3 entries may be
																present.	*/
	"/Leading",							/* 		number	(Optional) The desired spacing between baselines of consecutive lines of text.
																Default value: 0.	*/
	"/MaxWidth",						/* 	number	(Optional) The maximum width of glyphs in the font. Default value: 0.	*/
	"/MissingWidth",				/* 	number	(Optional) The width to use for character codes whose widths are not speci-
																fied in a font dictionarys Widths array. This has a predictable effect only if all
																such codes map to glyphs whose actual widths are the same as the Missing-
																Width value. Default value: 0.	*/
	"/StemH",								/* 		number	(Optional) The vertical width of the dominant horizontal stems of glyphs in
																the font. Default value: 0.	*/
	"/XHeight",							/* 		number	(Optional) The y coordinate of the top of flat nonascending lowercase letters,
																measured from the baseline. Default value: 0.	*/
	"/CharSet",							/* 		string	(Optional; meaningful only in Type 1 fonts; PDF 1.1) A string listing the character
																names defined in a subset font. The names in this string must be in PDF
																syntaxthat is, each name preceded by a slash (/). The names can appear in
																any order. The name .notdef should be omitted; it is assumed to exist in the
																font subset. If this entry is absent, the only indication of a subset font is the
																subset tag in the FontName entry (see Section 5.5.3, Font Subsets).	*/
	};



#define	FONT_TYPE					1
#define	FONT_SUBTYPE			2
#define	FONT_NAME					3
#define	FONT_FIRST				4
#define	FONT_LAST					5
#define	FONT_WIDTHS				6
#define	FONT_ENCODING			7
#define	FONT_BASEFONT			8
#define	FONT_DESCRIPT			9
#define	FONT_TOUNICODE		10
#define	FONT_DESCENDAND		11


char *fonts_command[]={
	"/Type",							/* Must be /Font				*/
	"/Subtype",						/* /TrueType						*/
	"/Name",							/* /F7									*/
	"/FirstChar",					/* 0										*/
	"/LastChar",					/* 122									*/
	"/Widths",						/* [333 0 0 0 .. 				*/
	"/Encoding",					/* /WinAnsiEncoding			*/
	"/BaseFont",					/* /MSTT319c623cc2T00+2	*/
	"/FontDescriptor",		/* 10 0 R								*/
	"/ToUnicode",
	"/DescendantFonts",		/*		*/
	NULL};


char *fonts_type_command[]=
{
"/Type0",			/*	Type 0 Type0 (PDF 1.2) A composite fonta font composed of
									other fonts, organized hierarchically (see Section 5.6,
									"Composite Fonts")		*/
"/Type1",			/*	Type 1 Type1 A font that defines glyph shapes by using a special
									encoded format (see Section 5.5.1, "Type 1 Fonts")
									MMType1 A multiple master fontan extension of the Type 1
									font that allows the generation of a wide variety of
									typeface styles from a single font (see "Multiple
									Master Fonts" on page 297)	*/
"/Type3",			/*	Type 3 A font that defines glyphs with streams of PDF
									graphics operators (see Section 5.5.4, "Type 3 Fonts")	*/
"/TrueType",	/*	TrueType A font based on the TrueType font format (see
									Section 5.5.2, "TrueType Fonts")		*/
"/CIDFontType0",			/*	CIDFont CIDFontType0 (PDF 1.2) A CIDFont whose glyph descriptions are
													based on Type 1 font technology (see Section 5.6.3,
													"CIDFonts")	*/
"/CIDFontType2",		/*	CIDFontType2 (PDF 1.2) A CIDFont whose glyph descriptions are
												based on TrueType font technology (see Section 5.6.3,
												"CIDFonts")	*/
NULL};



char *base_font_command[]=
{
"/Times-Roman",
"/TimesNewRomanPSMT",
"/TimesNewRoman",
"/TimesNewRomanPS",

"/Times-Bold",
"/TimesNewRomanPS-BoldMT",
"/TimesNewRoman,Bold",
"/TimesNewRomanPS-Bold",
"/TimesNewRoman-Bold",

"/Times-Italic",
"/TimesNewRomanPS-ItalicMT",
"/TimesNewRoman,Italic",
"/TimesNewRomanPS-Italic",
"/TimesNewRoman-Italic",

"/Times-BoldItalic",
"/TimesNewRomanPS-BoldItalicMT",
"/TimesNewRoman,BoldItalic",
"/TimesNewRomanPS-BoldItalic",
"/TimesNewRoman-BoldItalic",

"/Helvetica",
"/ArialMT",
"/Arial",

"/Helvetica-Bold",
"/Arial-BoldMT",
"/Arial,Bold",
"/Arial-Bold",
"/Helvetica,Bold",

"/Helvetica-Oblique",
"/Arial-ItalicMT",
"/Arial,Italic",
"/Arial-Italic",
"/Helvetica,Italic",
"/Helvetica-Italic",

"/Helvetica-BoldOblique",
"/Arial-BoldItalicMT",
"/Arial,BoldItalic",
"/Arial-BoldItalic",
"/Helvetica,BoldItalic",
"/Helvetica-BoldItalic",

"/Courier",
"/CourierNew",
"/CourierNewPSMT",

"/Courier-Bold",
"/CourierNew,Bold",
"/Courier,Bold",
"/CourierNewPS-BoldMT",
"/CourierNew-Bold",

"/Courier-Oblique",
"/CourierNew,Italic",
"/Courier,Italic",
"/CourierNewPS-ItalicMT",
"/CourierNew-Italic",

"/Courier-BoldOblique",
"/CourierNew,BoldItalic",
"/Courier,BoldItalic",
"/CourierNewPS-BoldItalicMT",
"/CourierNew-BoldItalic",

"/BPNAEA+TT856O00",					/* Unknown font	*/
"/BBIEIH+TimesNewRoman",
NULL
};


char *atari_base_font_command[]=
{
"Times New Roman",
"Times New RomanPSMT",
"Times New Roman",
"Times New RomanPS",

"Times Bold",
"Times New RomanPS BoldMT",
"Times New Roman Bold",
"Times New RomanPS Bold",
"Times New Roman Bold",

"Times Italic",
"Times New RomanPS ItalicMT",
"Times New Roman Italic",
"Times New RomanPS Italic",
"Times New Roman Italic",

"Times Bold Italic",
"Times New RomanPS Bold ItalicMT",
"Times New Roman Bold Italic",
"Times New RomanPS Bold Italic",
"Times New Roman Bold Italic",

"Helvetica",
"ArialMT",
"Arial",

"Helvetica Bold",
"Arial BoldMT",
"Arial Bold",
"Arial Bold",
"Helvetica Bold",

"Helvetica",
"Arial ItalicMT",
"Arial Italic",
"Arial Italic",
"Helvetica Italic",
"Helvetica Italic",

"Helvetica Bold Oblique",
"Arial Bold ItalicMT",
"Arial Bold Italic",
"Arial Bold Italic",
"Helvetica Bold Italic",
"Helvetica Bold Italic",

"Courier New",
"Courier New",
"Courier NewPSMT",

"Courier Bold",
"Courier New Bold",
"Courier Bold",
"Courier NewPS BoldMT",
"Courier New Bold",

"Courier Oblique",
"Courier New Italic",
"Courier Italic",
"Courier NewPS ItalicMT",
"Courier New Italic",

"Courier Bold Oblique",
"Courier New Bold Italic",
"Courier Bold Italic",
"Courier NewPS Bold ItalicMT",
"Courier New Bold Italic",

"Times Bold Italic",					/* BPNAEA+TT856O00	*/
"Times Bold Italic",					/* BBIEIH+TimesNewRoman	*/
NULL
};


char *fonts_encoding_command[]=
{
"/StandardEncoding",		/*	Adobe standard Latin-text encoding. This is the built-in encoding
					defined in Type 1 Latin-text font programs (but generally not in
					TrueType font programs). PDF does not have a predefined
					encoding named StandardEncoding. However, it is useful to
					describe this encoding, since a font's built-in encoding can be
					used as the base encoding from which differences are specified in
					an encoding dictionary.	*/
"/MacRomanEncoding",		/*	Mac OS standard encoding for Latin text in western European
					languages. PDF has a predefined encoding named
					MacRomanEncoding that can be used with both Type 1 and
					TrueType fonts.		*/
"/WinAnsiEncoding",		/*	Windows code page 1252, often called the "Windows ANSI"
					encoding. This is the standard Windows encoding for Latin text in
					western European languages. PDF has a predefined encoding
					named WinAnsiEncoding that can be used with both Type 1 and
					TrueType fonts.	*/
"/PDFDocEncoding",		/*	Encoding for text strings in a PDF document outside the
					document's content streams. This is one of two encodings (the
					other being Unicode) that can be used to represent text strings;
					see Section 3.8.1, "Text Strings." PDF does not have a predefined
					encoding named PDFDocEncoding; it is not customary to use this
					encoding to show text from fonts.	*/
"/MacExpertEncoding",		/*	An encoding for use with expert fontsones containing the
					expert character set. PDF has a predefined encoding named
					MacExpertEncoding. Despite its name, it is not a platform-specific
					encoding; however, only certain fonts have the appropriate
					character set for use with this encoding. No such fonts are among
					the standard 14 predefined fonts.	*/
"/ISOLatin1Encoding",
"/SymbolEncoding",
"/DingbatsEncoding",
"/Type",
"/BaseEncoding",
"/Differences",
"/Identity-H",				/*	The horizontal identity mapping for 2-byte CIDs; may be used with CIDFonts using any
													Registry, Ordering, and Supplement values. It maps 2-byte character codes ranging from
													0 to 65,535 to the same 2-byte CID value, interpreted high-order byte first (see below).	*/
"/Identity-V",				/*	Vertical version of Identity-H. The mapping is the same as for Identity-H.	*/
NULL
};

#define	ENCODING_TYPE		9
#define ENCODING_BASE		10
#define ENCODING_DIFF		11
#define ENCODING_IDEH		12
#define ENCODING_IDEV		13


void Free_font(struct page_resource *page_resource)
	{
	int i;

	if(page_resource->fonts)
		{
		for(i=(page_resource->fonts->loaded_fonts-1); i>-1; i--)
			{
			if(page_resource->fonts[i].descriptor)
				free(page_resource->fonts[i].descriptor);

			if(page_resource->fonts[i].width_table)
				free(page_resource->fonts[i].width_table);

			if(page_resource->fonts[i].encoding.differences)
				free(page_resource->fonts[i].encoding.differences);

			if(page_resource->fonts[i].width_table)
				free(page_resource->fonts[i].width_table);
			}
		free(page_resource->fonts);
		}
	}


struct font_descriptor *Load_font_descriptor(struct PDF_Info *pdf_info, struct fonts *tmp_font)
	{
	struct files_pdf *file = pdf_info->file_info;
	struct font_descriptor *tmp_desc;
	struct Rectangle *rect=NULL;
	int keep_going=1, i=0;

	file->actual_pos = (long)tmp_font->descriptor;

	tmp_desc = calloc(1, sizeof(struct font_descriptor));

	while(isdigit(file->buffer[file->actual_pos])==0)
		file->actual_pos++;
	GoToObject(pdf_info, (unsigned int)Read_object_no(file));

	if(tmp_desc!=NULL)
		{
		keep_going=1;
		while(keep_going!=0 && tmp_desc!=NULL)
			{
			switch((keep_going=Command2ID(file, fonts_descriptor_command)))
				{
				case 0:
					break;
				case FONT_DES_TYPE:
					if(Command2ID(file, types_command)!=7)
						{
						x_gem_alert("[3][Error in PDF structure.|Wrong type in the font descriptor object][ Hmmm...]", 0L);
						keep_going=0;
						break;
						}
					break;
				case FONT_DES_CAPHEIGHT:
					tmp_desc->CapHeight = (int)Read_object_no(file);
					break;
				case FONT_DES_ASCENT:
					tmp_desc->Ascent = (int)Read_object_no(file);
					break;
				case FONT_DES_DESCENT:
					tmp_desc->Descent = (int)Read_object_no(file);
					break;
				case FONT_DES_FLAGS:
					tmp_desc->Flags = (int)Read_object_no(file);
					break;
				case FONT_DES_FONTBBOX:
					if((rect=Read_rectangle(file))!=NULL)
						{
						memcpy(&tmp_desc->FontBBox, rect, sizeof(struct Rectangle));
						free(rect);
						}
						break;
				case FONT_DES_FONTNAME:
					i=0;
					while(file->buffer[file->actual_pos]!='/')
						file->actual_pos++;

					while(file->buffer[file->actual_pos]!=' ' && file->buffer[file->actual_pos]!='\n' && file->buffer[file->actual_pos]!='\r' && file->buffer[file->actual_pos]!='\\')
						{
						if(file->buffer[file->actual_pos]=='>')
							{
							file->actual_pos--;
								break;
							}
						tmp_desc->FontName[i++] = file->buffer[file->actual_pos++];
						}
					break;
				case FONT_DES_ITALIC:
					tmp_desc->ItalicAngle = (int)Read_object_no(file);
					break;
				case FONT_DES_STEMV:
					tmp_desc->StemV = (int)Read_object_no(file);
					break;
				case FONT_DES_AVGWIDTH:
					tmp_desc->AvgWidth = (int)Read_object_no(file);
					break;
				case FONT_DES_FONTFILE2:
					tmp_desc->FontFile2 = file->actual_pos;
					break;
				case FONT_DES_FONTFILE3:
					tmp_desc->FontFile3 = file->actual_pos;
					break;
				case FONT_DES_LEADING:
					tmp_desc->Leading = (int)Read_object_no(file);
					break;
				case FONT_DES_MAXWIDTH:
					tmp_desc->MaxWidth = (int)Read_object_no(file);
					break;
				case FONT_DES_MISSINGWIDTH:
					tmp_desc->MissingWidth = (int)Read_object_no(file);
					break;
				case FONT_DES_STEMH:
					tmp_desc->StemH = (int)Read_object_no(file);
					break;
				case FONT_DES_XHEIGHT:
					tmp_desc->XHeight = (int)Read_object_no(file);
					break;
				case FONT_DES_CHARSET:
					tmp_desc->CharSet = file->actual_pos;
					break;
				default:
					x_gem_alert("[3][Error in PDF structure.|Unknown command in font descriptor][ Hmmm...]", 0L);
					break;
				}
			}
		}

	GoBack(pdf_info);

	tmp_font->descriptor = calloc(1, sizeof(struct font_descriptor));
	memcpy(tmp_font->descriptor, tmp_desc, sizeof(struct font_descriptor));
	free(tmp_desc);

	return(tmp_font->descriptor);
	}



void Load_differences(struct PDF_Info *pdf_info, struct fonts *font, char *source, int type)
	{
	int start, i;
	struct Character_encoding *enc;

	while(isdigit(*source)==0)				/* Ok. first we have to find the starting point - a digit	*/
		source++;

	switch(type)
		{
		case 0:				/* Standard Encoding - unknown type		*/
		case 1:				/* Standard Encoding - Latin_encoding	*/
			{
			enc = (struct Character_encoding *)calloc(1, LATIN_SIZE*sizeof(struct Character_encoding));
			memcpy(enc, Latin_encoding, LATIN_SIZE*sizeof(struct Character_encoding));

			break;
			}
		case 2:				/* MacRoman Encoding									*/
			{
			enc = (struct Character_encoding *)calloc(1, MAC_SIZE*sizeof(struct Character_encoding));
			memcpy(enc, MacExpert_encoding, MAC_SIZE*sizeof(struct Character_encoding));

			break;
			}
		default:
			x_gem_alert("[3][Other encoding type!|Report this!!][OK]", 0L);
		}	/* Switch	*/



	while((*source)!=']' && (*(source+1))!=']' && (*(source-1))!=']')				/* It should be repeated so many times as we have characters -		*/
		{																							/* up to "]" character																						*/
		start = atoi(source);													/* Let's read the starting number																	*/
		while((*source)!='/')													/* Find first and next "/" character															*/
			source++;
		source++;
		while(isdigit(*source)==0)										/* Repeat it up to the next starting point												*/
			{
			for(i=0; enc[i].code.standard!=-1 && i<229; i++)		/* Find the name to replace															*/
				{
				if(strncmp(enc[i].name, source, min(strcspn(source, " /]"), strcspn(source, "\n")))==0)		/* Is this the name?			*/
					{
					source += strlen(enc[i].name);					/* Find first and next "/" character	*/
					if(*source==' ')
						source++;
					if(*source=='/')
						source++;

					enc[i].code.new_code = start;
					start++;
					break;
					}
				}
			if(enc[i].code.standard==-1 || i>=228)					/* Funny, but there is no char like this								*/
				{
				while((*source)!='/' && (*source)!=']')													/* Find next "/" character															*/
					source++;
				source++;
				}
			if((*source)==']' || (*(source+1))==']' || (*(source-1))==']')
				break;
			}
		}

	font->encoding.differences = (void*)enc;
	}


void Load_encoding(struct PDF_Info *pdf_info, struct fonts *font)
	{
	struct files_pdf *file = pdf_info->file_info;
	int keep_going=1;

	GoToObject(pdf_info, (unsigned int)Read_object_no(file));

	while(file->buffer[file->actual_pos]!='/')
		file->actual_pos++;

	while(keep_going!=0)
		{
		switch((keep_going=Command2ID(file, fonts_encoding_command)))
			{
			case ENCODING_TYPE:
						if((font->encoding.type=Command2ID(file, fonts_command))!=FONT_ENCODING)
							x_gem_alert("[3][Wrong parameters|in Encoding structure][Oops]", 0L);
						break;
			case ENCODING_BASE:
						font->encoding.base = Command2ID(file, fonts_encoding_command);
						break;
			case ENCODING_DIFF:
						Load_differences(pdf_info, font, &file->buffer[file->actual_pos], font->encoding.base);
						break;
			}
		}
	GoBack(pdf_info);
	}




void Load_font_object(struct PDF_Info *pdf_info, struct page_resource *resource)
	{
	struct files_pdf *file = pdf_info->file_info;
	char name[100]={0};
	struct fonts *tmp_font;
	unsigned long font_name_pos=0;
	int keep_going=1, i=0, o=2;
	int normal_fonts[]=	{1,	2,	3,	4, 20, 21, 22, 28, 40,41,42,48,-1};
	int italic_fonts[]=	{10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 29, 30, 31, 32, 33, 35,36,37,38,39,49,50,51,52,53,54,55,56,57,-1};
	int bold_fonts[]=		{5,	6,	7,	8,	9, 15, 16, 17, 18, 19, 23, 24, 25, 26, 27, 34, 35,36,37,38,39,43,44,45,46,47,53,54,55,56,57,-1};

	resource->fonts = NULL;

	for(; keep_going!=2 ;)
		{
		i=0; keep_going=1;
		while(file->buffer[file->actual_pos]!='/')
			{
			if(file->buffer[file->actual_pos]=='>')
				{
				keep_going=2;
				break;
				}
			file->actual_pos++;
			}

		if(keep_going==2)
			break;

		resource->fonts = Add_font(resource->fonts);
		tmp_font = &resource->fonts[resource->fonts->loaded_fonts-1];
		tmp_font->first_char = -1;
		tmp_font->last_char = -1;

		while(file->buffer[file->actual_pos]!=' ' && file->buffer[file->actual_pos]!='\n' && file->buffer[file->actual_pos]!='\r' && file->buffer[file->actual_pos]!='\\')
			tmp_font->name[i++] = file->buffer[file->actual_pos++];

		while(isdigit(file->buffer[file->actual_pos])==0)
			file->actual_pos++;
		GoToObject(pdf_info, (unsigned int)Read_object_no(file));


		if(tmp_font && keep_going!=2)
			{
			keep_going=1;
			while(keep_going!=0 && tmp_font!=NULL)
				{
				switch((keep_going=Command2ID(file, fonts_command)))
					{
					case FONT_TYPE:
								if(Command2ID(file, types_command)!=6)
									{
									x_gem_alert("[3][Error in PDF structure.|Wrong type in the fonts][ Hmmm...]", 0L);
									break;
									}
								break;
					case FONT_SUBTYPE:
								tmp_font->type = Command2ID(file, fonts_type_command);
								break;
					case FONT_NAME:
								i=0;
								while(file->buffer[file->actual_pos]!='/')
									file->actual_pos++;
								while(file->buffer[file->actual_pos]!=' ' && file->buffer[file->actual_pos]!='\n' && file->buffer[file->actual_pos]!='\r' && file->buffer[file->actual_pos]!='\\')
									{
									if(file->buffer[file->actual_pos]=='>')
										{
										file->actual_pos--;
										break;
										}
									tmp_font->name[i++] = file->buffer[file->actual_pos++];
									}
								break;
					case FONT_FIRST:
								tmp_font->first_char = (int)Read_object_no(file);
								break;
					case FONT_LAST:
								tmp_font->last_char = (int)Read_object_no(file);
								break;
					case FONT_WIDTHS:
								{
								int i;
								char buf[10]={0};

								if(tmp_font->first_char!=-1 && tmp_font->last_char!=-1)
									{
									tmp_font->width_table = calloc(1, 2*(tmp_font->last_char-tmp_font->first_char+2));
									if(file->buffer[file->actual_pos]=='[' || file->buffer[file->actual_pos+1]=='[')
										{
										while(isdigit(file->buffer[file->actual_pos])==0)
											file->actual_pos++;
										for(i=0; i<(tmp_font->last_char-tmp_font->first_char); i++)
											{
											tmp_font->width_table[i] = atoi(&file->buffer[file->actual_pos]);
											itoa(tmp_font->width_table[i], buf, 10);
											file->actual_pos += strlen(buf);
											file->actual_pos++;
											}
										}
									else
										x_gem_alert("[3][Other width format|in font structure][ok]", 0L);
									}
								break;
								}
					case FONT_ENCODING:
								if(file->buffer[file->actual_pos]=='/' || file->buffer[file->actual_pos+1]=='/')
									tmp_font->encoding.base = Command2ID(file, fonts_encoding_command);
								else
									{
									Load_encoding(pdf_info, tmp_font);
/*
									GoToObject(pdf_info, (unsigned int)Read_object_no(file));
									tmp_font->encoding = Command2ID(file, fonts_encoding_command);
									GoBack(pdf_info);
*/
									}
								break;
					case FONT_BASEFONT:
								font_name_pos = file->actual_pos;
								name[0]='/';
								strncpy(&name[1], &file->buffer[file->actual_pos+1], strcspn(&file->buffer[file->actual_pos+1], "\r\n[]></"));

								tmp_font->base_font = Command2ID(file, base_font_command);
								if(tmp_font->base_font==0)
									tmp_font->base_font=1;

								tmp_font->effect=0;
								for(i=0; normal_fonts[i]>1; i++)
									if(tmp_font->base_font == normal_fonts[i])
										tmp_font->effect=0;
								for(i=0; italic_fonts[i]>1; i++)
									if(tmp_font->base_font == italic_fonts[i])
										tmp_font->effect |= TXT_ITALIC;
								for(i=0; bold_fonts[i]>1; i++)
									if(tmp_font->base_font == bold_fonts[i])
										tmp_font->effect |= TXT_BOLD;

								if(strstr(strupr(name), "ITALIC") && !(tmp_font->effect&TXT_ITALIC))
									tmp_font->effect |= TXT_ITALIC;
								if(strstr(strupr(name), "BOLD") && !(tmp_font->effect&TXT_BOLD))
									tmp_font->effect |= TXT_BOLD;
								memset(name, 0, 100);
									
								break;
					case FONT_DESCRIPT:
								tmp_font->descriptor = (void*)file->actual_pos;
								break;
					case FONT_TOUNICODE:
								GoToObject(pdf_info, (unsigned int)Read_object_no(file));
								GoBack(pdf_info);
								break;
					case FONT_DESCENDAND:
								GoToObject(pdf_info, (unsigned int)Read_object_no(file));
								GoBack(pdf_info);
								break;
					default:
								break;
					}
				}
			keep_going=1;
			}

		if((tmp_font->type==2 || tmp_font->type==4) && tmp_font->base_font>=1)
			{
			i = vst_load_fonts(x_gem->handle, 0);
			for(; 0<i; i--)
				{
				o = vqt_name(x_gem->handle, i, name);
				if(strcmp(name, atari_base_font_command[tmp_font->base_font-1])==0)
					tmp_font->TT_id = 17746;		/*	o;	*/
				}
			vst_unload_fonts(x_gem->handle, 0);
			memset(name, 0, 100);
			}
		else if((tmp_font->type==2 || tmp_font->type==4) && tmp_font->base_font==0)
			{
			file->actual_pos = font_name_pos;
			tmp_font->TT_id = 17746;		/*5003*/


	/*		i=vst_load_fonts(x_gem->handle, 0);
			for(; 0<i; i--)
				{
				o = vqt_name(x_gem->handle, i, name);
				if(strcmp(name, atari_base_font_command[tmp_font->base_font-1])==0)
					tmp_font->TT_id = o;
				}
			vst_unload_fonts(x_gem->handle, 0);
			memset(name, 0, 100);
*/
			}

		if(tmp_font->descriptor!=NULL)
			tmp_font->descriptor = Load_font_descriptor(pdf_info, tmp_font);
		
		GoBack(pdf_info);
		}
	}



struct fonts *Add_font(struct fonts *font)
	{
	struct fonts *output=NULL;

	if(font==NULL)
		{
		output=calloc(1, sizeof(struct fonts));
		memset(output, 0, sizeof(struct fonts));
		output->loaded_fonts = 1;
		}
	else
		{
		output = calloc(font->loaded_fonts+1, sizeof(struct fonts));
		memset(output, 0, (font->loaded_fonts+1)*sizeof(struct fonts));
		memcpy(output, font, font->loaded_fonts*sizeof(struct fonts));
		free(font);
		output->loaded_fonts++;
		}
	return(output);
	}



struct fonts *SetFont (WIND_LIST *wind, char *name, struct page_resource *resource)
{
	short i = 0;
	struct fonts *tmp_font = resource->fonts;

	if (tmp_font)
	{
		while (i < tmp_font->loaded_fonts)
		{
			if (strncmp (tmp_font[i].name, name, strlen (tmp_font[i].name)) == 0)
			{
				add_pdf_object (wind, TEXT_OPERATORS + 4, (short)tmp_font[i].TT_id, (short)tmp_font[i].italic_angle, (short)tmp_font[i].effect);
				break;
			}
			i ++;
		}
	}

	return (&tmp_font[i]);
}
