#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"
#include	"options.h"
#include	"mypdf.h"
#include	"mypdf.rh"


#define MAX_BEADS 1000

#define PDF_INFO_Title				1
#define PDF_INFO_Author				2
#define PDF_INFO_Subject			3
#define PDF_INFO_Keywords			4
#define PDF_INFO_Creator			5
#define PDF_INFO_Producer			6
#define PDF_INFO_CreationDate	7
#define PDF_INFO_ModDate			8
#define PDF_INFO_Trapped			9
#define PDF_INFO_Version			10


char *Read_text(struct files_pdf *);
char *Read_command(struct files_pdf *);
int Command2ID(struct files_pdf *, char **);
unsigned long Read_object_no(struct files_pdf *);
struct Rectangle *Read_rectangle(struct files_pdf *);
char *Read_last_line(struct files_pdf *);
char *Read_line(struct files_pdf *);
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
struct Page_tree *read_Page_tree(struct files_pdf *);
long find_object_number (struct file_position *, int , unsigned int );
BOOLEAN load_objects(struct files_pdf);
BOOLEAN Load_objects(struct PDF_Info *,int);
void Depack_date(char *);

BOOLEAN GoToObject(struct PDF_Info *, unsigned int );
BOOLEAN GoBack(struct PDF_Info *);

extern struct opt options;
extern OBJECT *adr_popup_menu, *adr_popup_thread;
extern OBJECT *rs_trindex[];
extern char *docu_info_commands[];

extern struct Root_obj *read_root_obj(struct PDF_Trailer *trailer, struct PDF_Info *info);
struct docu_info *Read_docu_info(struct PDF_Info *);

struct PDF_Bead_dict *read_bead_dict(struct PDF_Info *, int );


char *docu_info_commands[]={
		"/Title",
		"/Author",
		"/Subject",
		"/Keywords",
		"/Creator",
		"/Producer",
		"/CreationDate",
		"/ModDate",
		"/Trapped",
		"/Version",
		NULL};


char *threads_commands[]={
		"/Type",
		"/F",
		"/I",
		NULL};

char *bead_dict_commands[]={
		"/Type",
		"/T",
		"/N",
		"/V",
		"/P",
		"/R",
		NULL};


BOOLEAN FreeThreads(struct PDF_Threads *thread)
	{
	struct PDF_Bead_dict *next_bead=NULL;
	int i=0;

	for(i=0; i<thread->threads_no; i++)
		{
		if(thread->threads[i].first_bead!=NULL)
			{
			next_bead = thread->threads[i].first_bead;
			while(next_bead->next!=NULL)
				{
				next_bead = next_bead->next;
				free(next_bead->prev);
				}
			free(next_bead);
			}
		if(thread->threads[i].I!=NULL)
			{
			if(thread->threads[i].I->Title)
				free(thread->threads[i].I->Title);
			if(thread->threads[i].I->Author)
				free(thread->threads[i].I->Author);
			if(thread->threads[i].I->Subject)
				free(thread->threads[i].I->Subject);
			if(thread->threads[i].I->Keywords)
				free(thread->threads[i].I->Keywords);
			if(thread->threads[i].I->Creator)
				free(thread->threads[i].I->Creator);
			if(thread->threads[i].I->Producer)
				free(thread->threads[i].I->Producer);
			if(thread->threads[i].I->CreationDate)
				free(thread->threads[i].I->CreationDate);
			if(thread->threads[i].I->ModDate)
				free(thread->threads[i].I->ModDate);
			free(thread->threads[i].I);
			}	
		}

	return(TRUE);
	}



struct docu_info *Read_short_docu_info(struct PDF_Info *info)
	{
	struct files_pdf *file = info->file_info;
	char *line, buf[256]={0};
	struct docu_info *doc_info=calloc (1, sizeof (struct PDF_Outline));
	int keep_going=1;

	if(doc_info)
	{
		Change_status(STATUS_PDF_READ_INFO, 0, 0);
		/*Change_status(STATUS_BAR1_UPDATE, 0, 0);*/

		line = Read_line(file);

		while(keep_going!=0)
		{
			switch((keep_going=Command2ID(file, docu_info_commands)))
			{
			case PDF_INFO_Title:
				if((line=Read_text(file))!=NULL)
					if ((doc_info->Title = malloc (strlen (line) + 1)) > 0L)
						strcpy (doc_info->Title, line);
				break;
			case PDF_INFO_Author:
				if((line=Read_text(file))!=NULL)
					if ((doc_info->Author = malloc (strlen (line) + 1)) > 0L)
						strcpy (doc_info->Author, line);
				break;
			case PDF_INFO_Subject:
				if((line=Read_text(file))!=NULL)
					if ((doc_info->Subject = malloc (strlen (line) + 1)) > 0L)
						strcpy (doc_info->Subject, line);
				break;
			case PDF_INFO_Keywords:
				if((line=Read_text(file))!=NULL)
					if ((doc_info->Keywords = malloc (strlen (line) + 1)) > 0L)
						strcpy (doc_info->Keywords, line);;
				break;
			case PDF_INFO_Creator:
				if((line=Read_text(file))!=NULL)
					if ((doc_info->Creator = malloc (strlen (line) + 1)) > 0L)
						strcpy (doc_info->Creator, line);
				break;
			case PDF_INFO_Producer:
					if((line=Read_text(file))!=NULL)
						if ((doc_info->Producer = malloc (strlen (line) + 1)) > 0L)
							strcpy (doc_info->Producer, line);
					break;
			case PDF_INFO_CreationDate:
				if((line=Read_text(file))!=NULL)
					{
					strcpy (buf, line);
					Depack_date (buf);
					if ((doc_info->CreationDate = malloc (strlen (line) + 1)) > 0L)
						strcpy (doc_info->CreationDate, line);
					Depack_date(doc_info->CreationDate);
					}
				break;
			case PDF_INFO_ModDate:
				line = Read_text(file);
				if(line)
					{
					strcpy (buf, line);
					Depack_date (buf);
					if ((doc_info->ModDate = malloc (strlen (line) + 1)) > 0L)
						strcpy (doc_info->ModDate, line);
					}
				break;
			default:
				break;
			}
		}
	}
	while(file->buffer[file->actual_pos++]!='>')	;
	return(doc_info);
}



struct PDF_Threads *read_thread(struct PDF_Info *info)
	{
	struct files_pdf *file = info->file_info;
	char *line=NULL;
	struct PDF_Threads *thread=NULL;
	int i=0, j=0, keep_going=1;

	thread = calloc (1, sizeof (struct PDF_Outline));

	GoToObject(info, (unsigned int)info->Root_obj->Threads);

	thread->obj_list = read_Page_tree(file);
	while((thread->obj_list[i++]).page_no!=-1)		;

	adr_popup_thread[0].ob_height = 0;					/* The submenu has zero height			*/
	thread->threads = calloc(i, sizeof(struct Threads));
	thread->threads_no = i;

	j=i-1;
	i=0;

	while(i<(j-1))
		{
		if(thread->threads)
			{
			GoToObject(info, (unsigned int)(thread->obj_list[i]).page_no);

			Read_line(file);

			while(keep_going!=0)
				{
				switch((keep_going=Command2ID(file, threads_commands)))
					{
					case THREADS_TYPE:
								line = Read_command(file);
								if(line)
									strcpy(thread->threads[i].Type, line);
								break;
					case THREADS_F:
								thread->threads[i].F = Read_object_no(file);
								break;
					case THREADS_I:
								thread->threads[i].I = Read_short_docu_info(info);
								x_set_ob_text (adr_popup_thread, THREADS_TEXT_1+i, thread->threads[i].I->Title);
								adr_popup_thread[0].ob_height += adr_popup_thread[THREADS_TEXT_1].ob_height;
								break;
					default:
								break;
					}
				}			/* while(keep_going!=0)		*/

			keep_going = 1;
			if(thread->threads[i].F)
				thread->threads[i].first_bead = read_bead_dict(info, (int)thread->threads[i].F);
			i++;
			GoBack(info);
			}
		}			/* while(i<(j-1))	*/

	adr_popup_menu[POPUP_M_THREADS].ob_state &= ~DISABLED;
	x_set_menu_hierarch (adr_popup_menu, POPUP_M_THREADS, POPUP_THREADS);

	GoBack(info);
	return(thread);
}



struct PDF_Bead_dict *read_bead_dict(struct PDF_Info *info, int obj_no)
	{
	struct files_pdf *file = info->file_info;
	char *line=NULL;
	struct PDF_Bead_dict *bead_dict=NULL, *prev_bead=NULL, *first_bead=NULL;
	struct Rectangle *R=NULL;
	int i=0, first_obj=0, keep_going=1;

	if(first_bead==NULL)
		first_bead = calloc (MAX_BEADS, sizeof (struct PDF_Bead_dict));

	while(obj_no>0 && obj_no!=first_obj)
		{
		if(first_obj==0)
			first_obj = obj_no;

		GoToObject(info, (unsigned int)obj_no);

		bead_dict = (struct PDF_Bead_dict*)(&first_bead[i]);
		memset(bead_dict, 0, sizeof (struct PDF_Bead_dict));
		bead_dict->next = NULL;
		bead_dict->prev = prev_bead;

		if(prev_bead!=NULL)
			prev_bead->next = bead_dict;

		line = Read_line(file);
		obj_no = 0;

		while(keep_going!=0)
			{
			switch((keep_going=Command2ID(file, bead_dict_commands)))
				{
				case BEAD_DICT_TYPE:						/* Type		;-)		*/
							line = Read_text(file);
							if(line)
								{
								strcpy(bead_dict->Type, line);
								free(line);
								}
							break;
				case BEAD_DICT_T:								/* The thread to which this bead belongs.	*/
							bead_dict->T = Read_object_no(file);
							break;
				case BEAD_DICT_N:								/* Next bead	*/
							bead_dict->N = Read_object_no(file);
							obj_no = (int)bead_dict->N;
							break;
				case BEAD_DICT_V:								/* The previous bead	*/
							bead_dict->V = Read_object_no(file);
							break;
				case BEAD_DICT_P:								/* The page object representing the page on which this bead appears.	*/
							bead_dict->P = Read_object_no(file);
							break;
				case BEAD_DICT_R:								/* A rectangle specifying the location of this bead on the page.	*/
							R = Read_rectangle(file);
							if(R)
								{
								bead_dict->R.x1 = R->x1;
								bead_dict->R.y1 = R->y1;
								bead_dict->R.x2 = R->x2;
								bead_dict->R.y2 = R->y2;
								free(R);
								}
							break;
				default:
							break;
				}
			}

		i++;
		GoBack(info);
		prev_bead = bead_dict;
		}
	realloc(first_bead, (i-1)*sizeof (struct PDF_Outline_dictionary));
	return(first_bead);
}