#include "status.h"
#include "rectang.h"
#include "objects.h"
#include "encrypt.h"
#include "root_obj.h"
#include "trailer.h"
#include "outline.h"
#include "threads.h"
#include "docu_inf.h"
#include "thumbna.h"
#include "pagetree.h"
#include "pagelabe.h"						/* 0.08 - RK	*/
#include "nametree.h"						/* 0.08 - RK	*/
#include "pictures.h"
#include "fonts_st.h"
#include "resource.h"						/* 0.09 - RK	*/
#include "annots.h"						/* 0.09 - RK	*/


typedef struct _mfdb_
{
        void *fd_addr;               /* Zeiger auf den Beginn des*/
                                     /* Speicherbereichs, z. B.  */
                                     /* Bildspeicherbasisadresse */
        int  fd_w;                   /* Blockbreite in Pixeln    */
        int  fd_h;                   /* Hhe des Blocks in Pixeln*/
        int  fd_wdwidth;             /* Blockbreite in Integern  */
        int  fd_stand;               /* 0 = gerteabhngiges Format
                                        1 = Standardformat       */
        int  fd_nplanes;             /* Anzahl der Farbebenen    */
        int  fd_r1, fd_r2, fd_r3;    /* reserviert               */
};


#ifndef BOOLEAN
	#define BOOLEAN	int
	#ifndef TRUE
		#define TRUE	1
		#define FALSE	0
		#define FAIL	-1
	#endif
#endif



typedef struct	PDF_Info
	{
	int zoom;																/* Zoom is the number from the popup or...	*/
	unsigned long zoom_x, zoom_y;
	unsigned long zoom_w, zoom_h;						/* ... the choosen size :-)									*/

	double scale;														/* Scale																		*/
	unsigned long page_h, page_w, off_x, off_y;
	unsigned long page_no;									/* Actual page (as real number, not PDF number !!!!)			*/

	char rand_type;													/* Type of info displayed on the left/right side of the document:
																							0 - Tree (index)
																							1 - thumbnails
																							2 - threads
																							3 - nothing	*/
	BOOLEAN over_picture;
	int over_picture_no;
	BOOLEAN over_annotation;
	struct
		{
		int act_pos, prev_pos;
			struct _jump_
			{
			unsigned long page_no;								/* Page number					*/
			unsigned long pos_x, pos_y;						/* Position in the text	*/
			unsigned long zoom;										/* With what zoom				*/
			BOOLEAN saved;												/* This variable is set only if there is something stored	*/
			}jump[20];
		}prev_pos;

	struct
		{
		unsigned long page_no;
		unsigned long cont_len;
		void *adress;
		}pages_contents[3];

	text_string	Title;
	text_string Author;
	text_string Subject;
	text_string Keywords;
	text_string Creator;
	text_string Producer;
	date_pdf		CreationDate;
	date_pdf		ModDate;
	name_pdf		Trapped;
	int					Version;
	int 				Info_object;
	int					PageType;										/*	Type of pages:
																							0 - Single Page
																							1 - OneColumn
																							2 - TwoColumnLeft
																							3 - TwoColumnRight						*/
	int					PageMode;										/*	A name object specifying how the document should be displayed when opened:
																							0 - None (default)
																							1 - Outlines
																							2 - Thumbnails
																							3 - Full screen	*/
	unsigned long error;										/* How many errors is in the file - speciall for checking new edited files	*/
	unsigned long error_where;							/* In which structure the errors accure	(TO DO)															*/
	int window_handle;											/*	VDI Window handle	*/
	int window_number;											/*	Window number	*/
	unsigned long pos_xref;
	struct	files_pdf		*file_info;					/*	File info																			*/
	struct	PDF_Trailer	*trailer;						/*	Trailer info																	*/
	struct	Encryption	*encryption;				/*	Encryption info																*/
	struct	file_position obj_position;			/*	Position of the first object									*/
	struct	Root_obj	*Root_obj;						/*	Root object																		*/
	struct	page_labels	*pagelabels;				/*	Page Labels (page numbering style) - 0.08 RK	*/
	struct	PDF_Outline *Outline;						/*	Outline of the document - 0.07 RK							*/
	struct	PDF_Threads *Threads;						/*	Threads of the document - 0.07 RK							*/
	struct	ThumbNail	*thumb;								/*	Thumbnail	*/
	struct	PDF_PageTree *pages;
	struct	PDF_Info *next_pdf_info;
	struct	PDF_Info *prev_pdf_info;
	struct	NameTree *name_tree;						/*	Name tree - v.0.08 RK													*/
	};


int find_command(char **, char *);