

#define NAMETREE_KIDS			1
#define NAMETREE_NAMES		2
#define NAMETREE_LIMITS		3

#define NAMETREE_DESTS			1
#define NAMETREE_AP					2
#define NAMETREE_JAVA				3
#define NAMETREE_PAGES			4
#define NAMETREE_TEMPLATES	5
#define NAMETREE_IDS				6
#define NAMETREE_URLS				7


typedef struct name_tree
	{
	struct Page_tree *Kids;				/*		array		(Root and intermediate nodes only; required in intermediate nodes; present in the root node
																			if and only if Names is not present) An array of indirect references to the immediate chil-dren
																			of this node. The children may be intermediate or leaf nodes.		*/
	unsigned long Names;					/*		array		(Root and leaf nodes only; required in leaf nodes; present in the root node if and only if Kids
																			is not present) An array of the form
																			[ key 1 value 1 key 2 value 2  key n value n ]
																			where each key i is a string and the corresponding value i is an indirect reference to the ob-ject
																			associated with that key. The keys are sorted in lexical order, as described below.	*/
	unsigned long Limits;					/*		array		(Intermediate and leaf nodes only; required) An array of two strings, specifying the (lexi-cally)
																			least and greatest keys included in the Names array of a leaf node or in the Names
																			arrays of any leaf nodes that are descendants of an intermediate node.	*/
	};



typedef struct NameTree
	{
	struct name_tree *Dests;			/*	name tree	(Optional; PDF 1.2) A name tree mapping name strings to destinations 
																		(see Named Destinations on page 387).	*/
	unsigned long dests;
	struct name_tree *AP;					/*	name tree	(Optional; PDF 1.3) A name tree mapping name strings to annotation
																		appearance streams (see Section 7.4.4, Appearance Streams).	*/
	unsigned long ap;
	struct name_tree *JavaScript;	/*	name tree	(Optional; PDF 1.3) A name tree mapping name strings to document-level 
																		Java-Script actions (see JavaScript Actions on page 458).	*/
	unsigned long javascript;
	struct name_tree *Pages;			/*	name tree	(Optional; PDF 1.3) A name tree mapping name strings to visible pages
																		for use in interactive forms (see Section 7.6.5, Named Pages).	*/
	unsigned long pages;
	struct name_tree *Templates;	/*	name tree	(Optional; PDF 1.3) A name tree mapping name strings to invisible
																		pages for use in interactive forms (see Section 7.6.5, Named Pages).	*/
	unsigned long templates;
	struct name_tree *IDS;				/*	name tree	(Optional; PDF 1.3) A name tree mapping content set IDs to Web Capture
																		content sets (see Section 8.5.3, Content Sets).	*/
	unsigned long ids;
	struct name_tree *URLS;				/*	name tree	(Optional; PDF 1.3) A name tree mapping uniform resource locators
																		(URLs) to Web Capture content sets (see Section 8.5.3, Content Sets).	*/
	unsigned long urls;
	};