struct Page_tree
	{
	int page_no;			/* Number of the page	*/
	int eval;					/* Evaluation number	*/
	char Type;				/*	*/
	};

#define PAGETREE_TYPE									1
#define PAGETREE_PARENT								2
#define PAGETREE_KIDS									3
#define PAGETREE_COUNT								4
#define PAGETREE_ID										5
#define PAGETREE_KIDS_Resources				6
#define PAGETREE_KIDS_MediaBox				7
#define PAGETREE_KIDS_CropBox					8
#define PAGETREE_KIDS_BleedBox				9
#define PAGETREE_KIDS_TrimBox					10
#define PAGETREE_KIDS_ArtBox					11
#define PAGETREE_KIDS_Contents				12
#define PAGETREE_KIDS_Rotate					13
#define PAGETREE_KIDS_Thumb						14
#define PAGETREE_KIDS_B								15
#define PAGETREE_KIDS_Dur							16
#define PAGETREE_KIDS_Trans						17
#define PAGETREE_KIDS_Annots					18
#define PAGETREE_KIDS_AA							19
#define PAGETREE_KIDS_PieceInfo				20
#define PAGETREE_KIDS_LastModified		21
#define PAGETREE_KIDS_StructParents		22
#define PAGETREE_KIDS_PZ							23
#define PAGETREE_KIDS_SeparationInfo	24


struct PDF_PageTree
	{
	int real_number;							/* The real number of an page									*/
	int already_loaded;						/* How many pages are already in memory																												*/
	int max_to_load;							/* How many can be loaded																																			*/
	char *Page_no;								/* Page number as a text																																			*/
	unsigned long page_in_pdf;		/* Page number as a object in the PDF file		*/
	int Type;											/* name				(Required) The type of PDF object that this dictionary describes; must be Pages for
																							a page tree node.	*/
	long Parent;									/* dictionary	(Required except in root node; must be an indirect reference)
																							The page tree node that
																							is the immediate parent of this one.	*/
	struct Page_tree *kids;				/* array			(Required) An array of indirect references to the immediate children of this node.
																							The children may be page objects or other page tree nodes.	*/
	struct PDF_PageTree *first_kid;

	long Count;										/* integer		(Required) The number of leaf nodes (page objects) that are descendants of this
																							node within the page tree.	*/


	char ID[256];								/*	string 		(Optional; PDF 1.3; indirect reference preferred) The digital identifier of the
																pages parent Web Capture content set (see Section 8.5.5, Object At-tributes
																Related to Web Capture).	*/

	long Resources;								/*	dictionary	(Required; inheritable) A dictionary containing any resources required by
																		the page (see Section 3.7.2, Resource Dictionaries). If the page requires
																		no resources, the value of this entry should be an empty dictionary; omit-ting
																		the entry entirely, or specifying a null value, indicates that the re-sources
																		are to be inherited from an ancestor node in the page tree.	*/
	
	struct Rectangle MediaBox;	/*	rectangle	(Required; inheritable) A rectangle (see Section 3.8.3, Rectangles), ex-pressed
																in default user space units, defining the maximum imageable area
																of the physical medium on which the page is to be printed (see
																Section 8.6.1, Page Boundaries).	*/
	unsigned long CropBox;			/*		rectangle	(Optional; inheritable) A rectangle, expressed in default user space units,
																defining the region to which the contents of the page are to be clipped
																(cropped) when displayed or printed (see Section 8.6.1, Page Bound-aries).
																Default value: the value of MediaBox.		*/
	unsigned long BleedBox;			/*	rectangle	(Optional; PDF 1.3) A rectangle, expressed in default user space units, de-fining
																the region to which the contents of the page should be clipped
																when output in a production environment (see Section 8.6.1, Page
																Boundaries). Default value: the value of CropBox.	*/
	unsigned long TrimBox;			/*	rectangle	(Optional; PDF 1.3) A rectangle, expressed in default user space units, de-fining
																the intended dimensions of the finished page after trimming (see
																Section 8.6.1, Page Boundaries). Default value: the value of CropBox.	*/
	unsigned long ArtBox;				/*		rectangle	(Optional; PDF 1.3) A rectangle, expressed in default user space units, de-fining
																the extent of the pages meaningful content (including potential
																white space) as intended by the pages creator (see Section 8.6.1, Page
																Boundaries). Default value: the value of CropBox.	*/
	size_t Contents;						/*	stream or array (Optional) A content stream (see Section 3.7.1, Content Streams) de-scribing
																the contents of this page. If this entry is absent, the page is empty.
																The value may be either a single stream or an array of streams. If it is an
																array, the effect is as if all of the streams in the array were concatenated, in
																order, to form a single stream. This allows a program generating a PDF
																file to create image objects and other resources as they occur, even though
																they interrupt the content stream. The division between streams may
																occur only at the boundaries between lexical tokens (see Section 3.1,
																Lexical Conventions), but is unrelated to the pages logical content or
																organization. Applications that consume or produce PDF files are not re-quired
																to preserve the existing structure of the Contents array.	*/
	int Rotate;									/*		integer		(Optional; inheritable) The number of degrees by which the page should
																be rotated clockwise when displayed or printed. The value must be a mul-tiple
																of 90. Default value: 0.	*/
	struct Page_tree *B;				/* array 		(Optional; PDF 1.1; recommended if the page contains article beads) An
																array of indirect references to article beads appearing on the page (see
																Section 7.3.2, Articles; see also implementation note 20 in Appendix H).
																The beads are listed in the array in natural reading order.	*/
	int Dur;										/*		number		(Optional; PDF 1.1) The pages display duration (also called its advance
																timing): the maximum length of time, in seconds, that the page will be
																displayed during presentations before the viewer application automatical-ly
																advances to the next page (see Section 7.3.3, Presentations). By de-fault,
																the viewer does not advance automatically.	*/
	long Trans;									/*		dictionary 	(Optional; PDF 1.1) A transition dictionary describing the transition
																effect to be used when displaying the page during presentations (see
																Section 7.3.3, Presentations).	*/

	struct ThumbNail	thumb;		/* Thumbnail	*/
	size_t Thumb;								/*		stream		(Optional) A stream object defining the pages thumbnail image (see
																Section 7.2.3, Thumbnail Images).	*/
	int how_many_thumbnails;

	struct annotations *annots;	/* Annotations ....	*/
	unsigned long Annots;				/* 		array 		(Optional) An array of annotation dictionaries representing annotations
																associated with the page (see Section 7.4, Annotations).	*/
	int how_many_annotations;
	long AA;										/* 		dictionary 	(Optional; PDF 1.2) An additional-actions dictionary defining actions to
																be performed when the page is opened or closed (see Section 7.5.2, Trig-ger
																Events; see also implementation note 21 in Appendix H).	*/
	long PieceInfo;							/*	dictionary 	(Optional; PDF 1.3) A page-piece dictionary associated with the page (see
																Section 8.4.1, Page-Piece Dictionaries).	*/
	date_pdf LastModified;			/* 	date 		(Optional unless PieceInfo is present; PDF 1.3) The date and time (see
																Section 3.8.2, Dates) when the pages contents were most recently mod-ified.	*/
	int StructParents;					/* 	integer 	(Required if the page contains structural content items; PDF 1.3) The inte-ger
																key of the pages entry in the structural parent tree (see Finding
																Structure Elements from Content Items on page 496).	*/
	int PZ;											/* 		number 		(Optional; PDF 1.3) The pages preferred zoom (magnification) factor: the
																factor by which it should be scaled to achieve the natural display magni-fication
																(see Section 8.5.5, Object Attributes Related to Web Capture).	*/
	long SeparationInfo;				/* 	dictionary 	(Optional; PDF 1.3) A separation dictionary containing information
																needed to generate color separations for the page (see Section 8.6.2, Sep-aration
																Dictionaries).	*/

/*	struct PDF_PageTree *prev;
	struct PDF_PageTree *next;		*/
	};