
#define ROOT_TYPE					1
#define ROOT_PAGES				2
#define ROOT_PAGELAB			3
#define ROOT_NAMES				4
#define ROOT_DESTS				5
#define ROOT_VIEWPREF			6
#define ROOT_PAGELAY			7
#define ROOT_PAGEMODE			8
#define ROOT_OUTLINES			9
#define ROOT_THREADS			10
#define ROOT_OPENACT			11
#define ROOT_URI					12
#define ROOT_ACROFORM			13
#define ROOT_STRTREEROOT	14
#define ROOT_SPIDERINFO		15
#define ROOT_JT						16
#define ROOT_SPIPAGEMAP		17


extern char *root_commands[];


struct Root_obj
	{
	int Type;					/* (Required) The type of PDF object that
												this dictionary describes; must be Catalog for
												the catalog dictionary.	*/

	unsigned long Pages;				/* (Required, must be an indirect reference)
												The page tree node that is the root of the 
												documents page tree (see Section 3.6.2, 
												Page Tree).	*/
	unsigned long PageLabels;		/* (Optional; PDF 1.3) 
												A number tree (see Section 3.8.5, Number Trees)
												defining the page labeling for the document.
												The keys in this tree are page indices; 
												the corresponding values are page label 
												dictionaries (see Section 7.3.1, Page Labels).
												Each page index denotes the first page to which 
												the specified page label dictionary applies.
												The tree must include a value for page index 0.	*/
	unsigned long Names;	/* (Optional; PDF 1.2) The documents name dictionary
													(see Section 3.6.3, Name Dictionary).	*/

	void *Dests;			/* (Optional; PDF 1.1; must be an indirect reference)
												A dictionary of names and corresponding
												destinations (see Named Destinations on page 387).	*/
	void *ViewerPreferences;	/* (Optional; PDF 1.2) A viewer preferences
															dictionary (see Section 7.1, Viewer Preferences)
															specifying the way the document is to be
															displayed on the screen. If this entry is 
															absent, viewer applications should use their 
															own current user preference settings.	*/
	char PageLayout[32];	/* (Optional) A name object specifying the page layout
													to be used when the document is opened:
														SinglePage Display one page at a time.
														OneColumn Display the pages in one column.
														TwoColumnLeft Display the pages in two columns,
																with odd-numbered
																pages on the left.
														TwoColumnRight Display the pages in two columns,
																with odd-numbered pages on the right.
													(See implementation note 18 in Appendix H.)
													Default value: SinglePage.	*/
	char PageMode[32];		/* (Optional) A name object specifying how the
													document should be displayed when opened:
														UseNone Neither document outline nor thumbnail
															images visible
														UseOutlines Document outline visible
														UseThumbs Thumbnail images visible
														FullScreen Fullscreen mode, with no menu bar,
															window controls, or any other window visible
													Default value: UseNone.		*/
	unsigned long Outlines;	/* (Optional; must be an indirect reference) The
													outline dictionary that is the root of the
													documents outline hierarchy (see Section 7.2.2,
													Document Outline).	*/
	unsigned long Threads;					/* (Optional; PDF 1.1; must be an indirect reference)
													An array of thread dictionaries representing the 
													documents article threads (see Section 7.3.2,
													Articles).	*/
	void *OpenAction;			/* (Optional; PDF 1.1) A value specifying a
														destination to be displayed or an action to be 
														performed when the document is opened. The value 
														is either an array defining a destination (see 
														Section 7.2.1, Destinations) or an action 
														dictionary representing an action (Section 7.5, 
														Actions). If this entry is absent, the document 
														should be opened to the top of the first page at 
														the default magnification factor.	*/
	void *URI;						/* (Optional) A dictionary containing document-level
													information for uni-form resource identifier (URI) 
													actions (see URI Actions on page 428).	*/
	void *AcroForm;				/* (Optional; PDF 1.2) The documents interactive
													form (AcroForm) dictionary (see Section 7.6.1, 
													Interactive Form Dictionary).	*/
	void *StructTreeRoot;	/* (Optional; PDF 1.3) The documents structure tree
													root dictionary (see Structure Hierarchy on 
													page 486).	*/
	void *SpiderInfo;			/* (Optional; PDF 1.3) A dictionary containing state
													information used by the Acrobat Web Capture
													(AcroSpider) plug-in extension (see Section 8.5.1, 
													Web Capture Information Dictionary).	*/
	long SPIPageMap;
	};



/*
1 0 obj
<< /Type /Catalog
/Pages 2 0 R
/Outlines 3 0 R
/PageMode /UseOutlines
>>
endobj


15112 0 obj
<< 
/Type /Catalog 
/Pages 15033 0 R 
/Outlines 15116 0 R 
/Names 15114 0 R 
/OpenAction 15113 0 R 
/PageMode /UseOutlines 
/JT 15109 0 R 
/PageLabels 15020 0 R 
/SPI:PageMap 15110 0 R 
>> 
endobj
*/